with trace

global function abs(object num)
  if atom(num) then
    if num < 0 then
      return num*-1
    else
      return num
    end if
  else
    for i = 1 to length(num) do
      if atom(num[i]) then
        if num[i] < 0 then
          num[i] = num[i] * -1
        end if
      else return 0
      end if
    end for
    return num
  end if
end function

global function ship_dimensions(sequence Ship)  -- returns {length, height} of ships
  sequence dimensions
  dimensions = {}

  dimensions = append(dimensions,length(Ship[2][1]))
  dimensions = append(dimensions,length(Ship[2]))
  
  return dimensions
end function

global procedure Disp_Selected(sequence Ship)
  sequence center_of_ship
  center_of_ship = ship_dimensions(Ship)
  target_coords = {}

  center_of_ship[1] = Ship[1][1] + (center_of_ship[1]/2)
  center_of_ship[2] = Ship[1][2] + (center_of_ship[2]/2)
  target_coords = append(target_coords,(center_of_ship[1] - select_dim[1]/2))
  target_coords = append(target_coords,(center_of_ship[2] - select_dim[2]/2))
  mouse_pointer(0)
  display_image(target_coords,SELECTED)
  display_image(Ship[1],Ship[2])
  mouse_pointer(1)

end procedure

global function Clicked_On(sequence Ship)
  sequence dims
  dims = ship_dimensions(Ship)
  
  if MOUSE_EVENT[X] > Ship[1][1] and MOUSE_EVENT[X] < (Ship[1][1] + dims[1]) then
    if MOUSE_EVENT[Y] > Ship[1][2] and MOUSE_EVENT[Y] < (Ship[1][2] + dims[2]) then
      Disp_Selected(Ship)
      return 1
    else
      return 0
    end if
  else
    return 0
  end if
end function

global function Find_Clicked_Ship()
  if MOUSE_EVENT[Y] > 440 then return current_ship end if
  for i = 1 to length(ships) do
    if Clicked_On(ships[i][SPRITE]) then
      return ships[i]
    else
      if i = length(ships) then
        return {}
      end if
    end if
  end for
end function

global procedure ShipInfo_Popup()
  sequence scrn_buff
  object mouse_e 
  integer ok_btn
  
  mouse_pointer(0)
  scrn_buff = save_image({0,0},{640,480})
  delete_button(mnmenu_btn,BLUE)
  bk_color(BLUE)
  clear_screen()
  draw_line(WHITE, {{0,0},{0,479},{639,479},{639,0},{0,0}})
  draw_line(BRIGHT_BLUE, {{1,1},{1,478},{638,478},{638,1},{1,1}})
  ok_btn = draw_button({540,450},90,20,"OK",BRIGHT_BLUE,YELLOW)
  putsxy({10,10},"Name: "&current_ship[1],WHITE, 0,1)
  putsxy({10,30},"Class: "&current_ship[2],WHITE, 0,1)
  mouse_pointer(1)

  mouse_e = get_mouse()
  while 1 do
    mouse_e = get_mouse()
    if check_buttons(mouse_e) = ok_btn then exit end if
  end while

  mouse_pointer(0)
  delete_button(ok_btn,BLUE)
  clear_screen()
  display_image({0,0},scrn_buff)
  bk_color(BLACK)
  mnmenu_btn = draw_button({520,448},90,25,"Main Menu",BRIGHT_BLUE, YELLOW)
  mouse_pointer(1)

end procedure

global procedure Main_Menu_Pop()
  sequence scrn_buff
  object mouse_e
  integer rtngame_btn, quit_btn
  mouse_pointer(0)
  scrn_buff = save_image({0,0},{640,480})
  mouse_pointer(1)

  polygon(BLUE, 1, {{222, 102}, {222, 398}, {418, 398},{418,102},{222,102}})

  draw_line(WHITE, {{220,100},{220,400},{420,400},{420,100},{220,100}})
  draw_line(BRIGHT_BLUE, {{221,101},{221,399},{419,399},{419,101},{221,101}})
  rtngame_btn = draw_button({230,110},180,30,"Return",BRIGHT_BLUE,YELLOW)
  quit_btn = draw_button({230,160},180,30,"Quit",BRIGHT_BLUE,YELLOW)

  mouse_e = get_mouse()
  while 1 do
    mouse_e = get_mouse()
    if check_buttons(mouse_e) = quit_btn then 
      gm = graphics_mode(-1)
      abort(0)
    elsif check_buttons(mouse_e) = rtngame_btn then
      exit
    end if
  end while
  
  mouse_pointer(0)
  delete_button(rtngame_btn, BLUE)
  delete_button(quit_btn, BLUE)
  clear_screen()
  display_image({0,0},scrn_buff)
  mouse_pointer(1)
end procedure
  



 
    